;BOHRTAB.LSP
;***********
(setq cmdecho (getvar "cmdecho"))
(setq textstyle (getvar "textstyle"))
(setq snapunit (getvar "snapunit"))
(setq luprec (getvar "luprec"))
(setq clayer (getvar "clayer"))
(setq bemnz (getvar "dimzin"))
(setq osmode (getvar "osmode"))
(command "BKS" "s" "bohrtab")
(command "BKS" "w")
(setvar "cmdecho" 0)
(if (= (tblsearch "style" "bohrtab") nil)
     (command "STIL" "STANDARD" "monotxt" 0 0.8 0 "n" "n" "n")
)
(command "FANG" 2.5)
(setvar "luprec" 2)
(setvar "dimzin" 0)
(setvar "osmode" 0)
(command "LAYER" "ma" "bohrtab" "fa" "2" "bohrtab" "")
(setq np (getpoint "\nNullpunkt der Bohrungskoordinaten: "))
(setq npx (car np))
(setq npy (cadr np))
(setvar "lastpoint" np)
(command "LINIE" "@1.5<90" "@3<-90" "")
(command "REIHE" "l" "" "p" np 6 180 "j")
(prompt "\nBohrungen fr Tabelle auswhlen: ")
(setq asatz (ssget))
(prompt "\n")
(if (/= asatz nil)
     (progn
          (setq pt (getpoint "Bohrungstabelle wohin? (linker oberer Eckpunkt): "))
          (prompt "\n")
          (setq elzahl (sslength asatz))
          (setq z 1)
          (while (<= z elzahl)
               (if (= (cdr (assoc 0 (entget (ssname asatz (- z 1))))) "CIRCLE")
                    (setq z (+ z 1))
                    (progn
                         (ssdel (ssname asatz (- z 1)) asatz)
                         (setq elzahl (- elzahl 1))
                    )
               )
          )
          (setq asatzsort (ssadd))
          (setq elzahl (sslength asatz))
          (setq elzahlsort (sslength asatz))
          (setq zsort 1)
          (while (<= zsort elzahlsort)
               (setq rmax 0)
               (setq z 1)
               (while (<= z elzahl)
                    (setq r (cdr (assoc 40 (entget (ssname asatz (- z 1))))))
                    (if (>= r rmax)
                         (progn
                              (setq rmax r)
                              (setq elnr (- z 1))
                         )
                    )
                    (setq z (+ z 1))
               )
               (ssadd (ssname asatz elnr) asatzsort)
               (ssdel (ssname asatz elnr) asatz)
               (setq zsort (+ zsort 1))
               (setq elzahl (- elzahl 1))
          )
          (setq z 1)
          (setq mpliste (list (list '(0 0 0) 1)))
          (while (<= z elzahlsort)
               (setq mp (cdr (assoc 10 (entget (ssname asatzsort (- z 1))))))
               (setq pos 0)
               (setq vorh 0)
               (while (and (<= pos (- (length mpliste) 1)) (= vorh 0))
                    (if (equal mp (car (nth pos mpliste)))
                         (setq vorh 1)
                         (setq pos (+ pos 1))
                    )
               )
               (if (= vorh 1)
                    (progn
                         (setq mp1 (car (nth pos mpliste)))
                         (setq w (cadr (nth pos mpliste)))
                         (setq w (+ w 1))
                         (if (> w 4)
                              (setq w 1)
                         )
                         (setq neu (list mp1 w))
                         (setq mpliste (subst neu (nth pos mpliste) mpliste))
                    )
                    (progn
                         (setq mpliste (append mpliste (list (list mp 1))))
                         (setq w 1)
                    )
               )
               (cond
                    ((= w 1) (setq x 2.5 y 2.5))
                    ((= w 2) (setq x 2.5 y -2.5))
                    ((= w 3) (setq x -2.5 y -2.5))
                    ((= w 4) (setq x -2.5 y 2.5))
               )
               (command "TEXT" "p" "m" mp 3 0 z)
               (command "SCHIEBEN" "l" "" (list x y) "")
               (setq z (+ z 1))
          )
          (command "BKS" "u" pt)
          (command "TEXT" "0,-5" 4 0 "%%uBohrungstabelle")
          (command "TEXT" "p" "r" "6,-15" 3 0 "Nr.")
          (command "TEXT" "p" "z" "18,-15" 3 0 "X-Wert")
          (command "TEXT" "p" "z" "38,-15" 3 0 "Y-Wert")
          (command "TEXT" "p" "z" "58,-15" 3 0 "%%c")
          (command "TEXT" "70,-15" 3 0 "Bemerkung")
          (setq ly (- -20 (* elzahlsort 5)))
          (command "LINIE" "0,-18" "100,-18" "")
          (command "LINIE" "8,-11" (list 8 ly) "")
          (command "LINIE" "28,-11" (list 28 ly) "")
          (command "LINIE" "48,-11" (list 48 ly) "")
          (command "LINIE" "68,-11" (list 68 ly) "")
          (setq z 1)
          (while (<= z elzahlsort)
               (setq y (- -20 (* z 5)))
               (setq mp (cdr (assoc 10 (entget (ssname asatzsort (- z 1))))))
               (setq r (cdr (assoc 40 (entget (ssname asatzsort (- z 1))))))
               (setq xwert (- (car mp) npx))
               (setq ywert (- (cadr mp) npy))
               (command "TEXT" "p" "r" (list 4.5 y) 3 0 z)
               (command "TEXT" "p" "r" (list 25.5 y) 3 0 (rtos xwert))
               (command "TEXT" "p" "r" (list 45.5 y) 3 0 (rtos ywert))
               (command "TEXT" "p" "r" (list 65.5 y) 3 0 (rtos (* r 2)))
               (setq z (+ z 1))
          )
     )
)
(command "TEXT" "s" textstyle (command))
(command "FANG" "as" (car snapunit) (cadr snapunit))
(setvar "luprec" luprec)
(command "LAYER" "se" clayer "")
(command "BKS" "h" "bohrtab")
(command "BKS" "l" "bohrtab")
(command "LAYER" "ein" "*" "se" clayer "")
(setvar "cmdecho" cmdecho)
(setvar "dimzin" bemnz)
(setvar "osmode" osmode)
